---
- name: Set OS
  hosts: "{{ target_hosts }}"
  vars_files:
    - ../vars.yml
  tasks:
    - name: Create nexus dir
      ansible.builtin.file:
        path: /srv/nexus-data
        owner: 200
        mode: '0775'
        state: directory

    - name: Create sonarqube data dir
      ansible.builtin.file:
        path: "{{ sonar_dir }}/data"
        owner: 200
        mode: '0775'
        state: directory

    - name: Create sonarqube extensions dir
      ansible.builtin.file:
        path: "{{ sonar_dir }}/extensions"
        owner: 200
        mode: '0775'
        state: directory

    - name: Create sonarqube logs dir
      ansible.builtin.file:
        path: "{{ sonar_dir }}/logs"
        owner: 200
        mode: '0775'
        state: directory

    - name: Create postgres data dir
      ansible.builtin.file:
        path: "{{ sonar_dir }}/postgres/data"
        owner: 999
        mode: '0775'
        state: directory

    - name: Create gitlab config dir
      ansible.builtin.file:
        path: "{{ gitlab_dir }}/config"
        owner: 1000
        mode: '0775'
        state: directory

    - name: Create gitlab logs dir
      ansible.builtin.file:
        path: "{{ gitlab_dir }}/logs"
        owner: 1000
        mode: '0775'
        state: directory

    - name: Create gitlab data dir
      ansible.builtin.file:
        path: "{{ gitlab_dir }}/data"
        owner: 1000
        mode: '0775'
        state: directory

    - name: Create gitlab ssl dir
      ansible.builtin.file:
        path: "{{ gitlab_dir }}/ssl"
        owner: 1000
        mode: '0775'
        state: directory

    - name: Create nginx ssl dir
      ansible.builtin.file:
        path: "{{ nginx_dir }}/ssl"
        owner: 200
        mode: '0775'
        state: directory

    - name: Create nginx conf.d dir
      ansible.builtin.file:
        path: "{{ nginx_dir }}/conf.d"
        owner: 200
        mode: '0775'
        state: directory

    - name: Create nginx cache dir
      ansible.builtin.file:
        path: "{{ nginx_dir }}/cache"
        owner: 200
        mode: '0775'
        state: directory

    - name: Verifiy if the ruleset already exists
      stat:
        path: "{{ nginx_dir }}/owasp-crs"
      register: owaspcrsdir

    - name: Download CRS rules
      when: not owaspcrsdir.stat.exists
      ansible.builtin.unarchive:
        src: https://github.com/coreruleset/coreruleset/archive/refs/tags/v3.3.2.tar.gz
        dest: "{{ nginx_dir }}"
        remote_src: yes

    - name: Rename CRS folder
      when: not owaspcrsdir.stat.exists
      command: mv "{{ nginx_dir }}/coreruleset-3.3.2" "{{ nginx_dir }}/owasp-crs"        

    - name: Rename crs-setup.conf.example file to crs-setup.conf
      when: not owaspcrsdir.stat.exists
      command: mv "{{ nginx_dir }}/owasp-crs/crs-setup.conf.example" "{{ nginx_dir }}/owasp-crs/crs-setup.conf"  
